#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "lodsav.h"
#include "pngio.h"

int getwh(char *k, int *Rw, int *Rh)
{
  int w,h,L;
  if (!k) return 1;
  L= strlen(k);
  if (L<=4) return 1;
  w= (k[0]-'0')*10+(k[1]-'0');
  h= (k[2]-'0')*10+(k[3]-'0');
  if (w<=0 || h<=0 || w>32 || h>32) return 1;
  if (L<w*h+4) return 1;
  *Rw= w;
  *Rh= h;
  return 0;
}

char** load_file(char *fn)
{
  char g[4000];
  char *lines[1000];
  int nlines;
  int i;
  int w,h;
  FILE *f;
  char **R;
  f= fopen(fn,"rb");
  if (!f) return NULL; 
  nlines= 0;
  while(1)
  {
    if (!fgets(g, sizeof(g), f)) break;
    g[sizeof(g)-1]= 0;
    for(i=0;g[i] && i<sizeof(g);i++)
      if (g[i]=='\r' || g[i]=='\n') { g[i]= 0; break; }
    if (getwh(g,&w,&h)) continue;
    lines[nlines++]= strdup(g);
  }
  fclose(f);
  R= malloc(sizeof(*R)*(nlines+1));
  for(i=0;i<nlines;i++)
   R[i]= lines[i];
  R[i]= NULL;
  return R;
}

int save_file(char *fn,char **lines)
{
  FILE *f;
  int i;
  f= fopen(fn,"wb");
  if (!f) return 1; 
  for(i=0;lines[i];i++)
   fprintf(f, "%s\n", lines[i]);
  fclose(f);
  return 0;
}

int export_c_file(char *fn, char **lines)
{
  FILE *f;
  int i,j,w,h;
  int pat;
  char *g;

  f= fopen(fn,"wb");
  if (!f) return 1; 
  fprintf(f,"static char *PAT[]= {\n");
  pat= 0;
  for(i=0;lines[i];i++)
  {
    g= lines[i];
    if (getwh(g,&w,&h)) continue;
    pat++;
    g+= 4;
    fprintf(f,"\"\\%03o\\%03o",w,h);
    for(j=0;g[j] && j<w*h;j++)
     fprintf(f,"\\%d", g[j]-'0');
    fprintf(f,"\",\n");
  }
  fprintf(f,"};\n");
  fprintf(f,"#define NPAT %d\n", pat);
  fclose(f);
  return 0;
}

static unsigned int colors[]=
  { 0,  0xFFff0000, 0xFF00ffff, 0xFFeeD5b7, 0xFFee9a00 };

int export_png_file(char *fn, char **lines,int wlimit)
{
  int i, w, h, th, tw, maxh,maxw,rp, Wimg, Himg, yoffset, x,y;
  unsigned int *image;
  char **olines;
  char *werr;
  image= NULL;
  olines= lines;

  th= 0;
  maxw= 0;
nextrow:
  tw= 0;
  maxh= 0;
  rp= 0;
  for(i=0;lines[i];i++)
  {
    if (getwh(lines[i],&w,&h)) continue;
    if ((tw+w>wlimit) && rp) break;
    if (h>maxh) maxh= h;
    rp++;
    tw+= w;
  }
  th += maxh;
  lines+= i;
  if (tw>maxw) maxw= tw;
  if (lines[0]) goto nextrow;

  Wimg= maxw;
  Himg= th;
  image= calloc(th*maxw,sizeof(image[0]));
  lines= olines;
  yoffset= 0;
putnextrow:
  tw= 0;
  rp= 0;
  maxh= 0;
  for(i=0;lines[i];i++)
  {
    if (getwh(lines[i],&w,&h)) continue;
    if ((tw+w>wlimit) && rp) break;
    for(y=0;y<h;y++)
     for(x=0;x<w;x++)
       image[ (x+tw) + (y+yoffset)*Wimg ]= colors[ lines[i][x+y*w+4]-'0' ];
    tw+= w;
    rp++;
    if (h>maxh) maxh= h;
  }
  yoffset+= maxh;
  lines+= i;
  if (lines[0]) goto putnextrow;

  for(i=0;i<Wimg*Himg;i++) image[i] |= (0xff<<24);

  werr= write_png_image(fn, Wimg, Himg, image);
  free(image);
  if (werr) return 1;
  return 0;
}

